#! /bin/awk -f

BEGIN {
  OFS = "";
  ORS = "";
  n = 0;
  FD = "dict.c";
  C = "builtins.c";
  CH = "builtins.h"
  H = "dict.h";
  WH = "words.h";
  print "/* automatically generated */\n\n" > C;
  print "#include \"builtins.h\"\n" > C;
  print "#include \"words.h\"\n" > C;
  print "#include \"sif.h\"\n\n\n" > C;
  print "wordfn builtins[] = {" > C;

  print "/* automatically generated */\n\n" > CH;
  print "#include \"sif.h\"\n\n" > CH;
  print "typedef void (*wordfn)(sif*);\n\n" > CH;
  print "extern wordfn builtins[];\n\n" > CH;

  print "/* automatically generated */\n\n" > H;


  print "/* automatically generated */\n\n" > FD;

  print "#include \"sif.h\"\n" > FD;
  print "#include \"words.h\"\n\n" > FD;

  print "void init_dictionary(sif* s)\n{\n" > FD;
  print "   unsigned char* dictionary = s->dictionary;\n\n" > FD;

}

/void [ic]_/ {
  print "void " $2 ";\n" > WH; # output function prototype for word

  sub(/\(sif\*s\)/, "", $2);
  if (n != 0) print "," > C;
  print "\n\t&" $2 > C;

  print "#define " toupper($2) " " n "\n\n" > WH; # give each function a number
  ++n;

  if($3 == "/*")
    fname = $4;
  else
    {
      fname = $2;
      sub(/[ci]_/, "", fname);
    }

  if(match($2, "^i_"))
    is_immediate = "NOT_IMMEDIATE";
  else
    is_immediate = "IS_IMMEDIATE";

  print "   dictionary -= DICTIONARY_ENTRY_SIZE;\n" > FD;
  print "   *((int*)dictionary) = hash_name(\"" fname "\", " length(fname)");\n" > FD;
  print "   s->cur_dictionary += DICTIONARY_ENTRY_SIZE;\n" > FD;
  
  print "   ((cell*)(dictionary + 4))[0] = " toupper($2) ";\n" > FD;
  print "   ((cell*)(dictionary + 4))[1] = " is_immediate ";\n\n" > FD;
}



END {
  print "\n};\n" > C;
  print "\n\n#define NUM_BUILTINS " n "\n" > CH;
  print "}\n" > FD;
}
