#include <stdio.h>
#include <errno.h>

#include "sif.h"

int run_with_memory(void* mem, int size)
{
  int err;
  sif s;

  err = sif_init(&s, mem, size); /* set all the default parameters and install dictionary */
  if(err)
    {
      fprintf(stderr, "sif_init returned error code %i\n", err);
      return err;
    }

  return quit(&s);
}

int run()
{
  void* mem = (void*)malloc(MEM_SIZE);
  if(mem == 0)
    {
      fprintf(stderr, "malloc() failed. errno: %i\n", errno);
      return ERROR_NO_MEM;
    }
  
  return run_with_memory(mem, MEM_SIZE);
}

int main(int argc, char *argv[])
{
  if(argc > 1)
    {
      fprintf(stderr, "sif Safe Interpreted Forth\nUsage: sif\n");
      return ERROR_USAGE;
    }
  return run();
}
